// mainfrm.cpp : implementation of the CMainFrame class
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "stdafx.h"
#include "chatter.h"

#include "mainfrm.h"
#include "chatdoc.h"
#include "chatvw.h"
#include "sendvw.h"
#include "VerifyDlg.h"
#include "UserInfoDlg.h"
#include "sec\UserCrypto_i.c"
#include "sec\UserCrypto.h"
#include "checkDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_ONLINEUSER, OnOnlineuser)
	ON_COMMAND(ID_VERIFY, OnVerify)
	ON_COMMAND(ID_SIGN, OnSign)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars
	
// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
	// same order as in the bitmap 'toolbar.bmp'
	ID_FILE_NEW,
	ID_FILE_SAVE,
		ID_SEPARATOR,
	ID_APP_ABOUT,
};

static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_pDlg = new CVerifyDlg(this);
}

CMainFrame::~CMainFrame()
{
	delete m_pDlg;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
		!m_wndToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		return -1;      // fail to create
	}

#ifdef _WIN32
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() | CBRS_TOOLTIPS | CBRS_FLYBY);
#endif

	return 0;
}

BOOL CMainFrame::OnCreateClient( LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	if (m_wndSplitter.CreateStatic(this,2,1))
	{
		CRect rect;
		GetClientRect(&rect);
		CSize size = rect.Size();
		size.cy-=150;
		if (m_wndSplitter.CreateView(0,0,RUNTIME_CLASS(CChatView),size,pContext))
		{
			if (m_wndSplitter.CreateView(1,0,RUNTIME_CLASS(CSendView),CSize(0,0),pContext))
			{
				SetActiveView((CView*)m_wndSplitter.GetPane(1,0));
				return TRUE;	
			}
		}
	}
	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnOnlineuser() 
{
	// TODO: Add your command handler code here
	CUserInfoDlg dlg;
	dlg.DoModal();
}

void CMainFrame::OnVerify() 
{
	if( m_pDlg->GetSafeHwnd() == 0){
		m_pDlg->Create();
	}
}

extern void compute_hash(char* ptr, unsigned char* digest);
extern CSendView* pSendView;
extern void Randomize(DWORD*, int);
extern CString ToString(DWORD*, int);

void CMainFrame::OnSign() 
{
	DWORD temp[32];
	DWORD ans_temp[32];
	BYTE* pDigest;
	CCheckDlg dlg;
	pDigest=(BYTE*)(& (temp[10]));
	Randomize(temp, 30);
	temp[31]=0; temp[30]=0;
	CChatDoc* pDoc = pSendView->GetDocument();
	ASSERT_VALID(pDoc);

	CString strText;
	pSendView->GetEditCtrl().GetWindowText(strText);

	dlg.m_strMsg = strText;
	if(dlg.DoModal()!=IDOK){
		return;
	}

	compute_hash((char*)(LPCTSTR) strText, pDigest);

	IUserRSA* pUserRSA;
	HRESULT hr = CoCreateInstance(CLSID_UserRSA,
	NULL, 
	CLSCTX_INPROC_SERVER, 
	IID_IUserRSA, 
	(void **)&pUserRSA);
	if(hr==REGDB_E_CLASSNOTREG){
		AfxMessageBox("REGDB_E_CLASSNOTREG ");
	}
	if(hr==CLASS_E_NOAGGREGATION){
		AfxMessageBox("CLASS_E_NOAGGREGATION ");
	}
	if(FAILED(hr)){
		AfxMessageBox("IUserRSA failed");
		return;
	}
	if(pUserRSA->LoadFile((unsigned char*)(LPCTSTR) pDoc->m_strKeyFile) != S_OK){
		AfxMessageBox("Private Key File format error!");
		return;
	}
	int ans=32;

	pUserRSA->ExpModPrivate(temp, 32, ans_temp, &ans);
	pUserRSA->Release();

	strText = strText + " [SIGNATURE] " + ToString(ans_temp, 32);

	pDoc->SendMsg(strText);

	strText=_T("");
	pSendView->GetEditCtrl().SetWindowText(strText);
}
