#include "stdafx.h"
#include "data.h"
#include <stdlib.h>

IMPLEMENT_SERIAL(CUserInfo, CObject, 1)
IMPLEMENT_SECSERIAL(CUserInfo)

IMPLEMENT_SERIAL(CUserList, CObject, 1)
IMPLEMENT_SECSERIAL(CUserList)

IMPLEMENT_SERIAL(COnlineUser, CObject, 1)
IMPLEMENT_SECSERIAL(COnlineUser)

IMPLEMENT_SERIAL(COnlineUserList, CObject, 1)
IMPLEMENT_SECSERIAL(COnlineUserList)

IMPLEMENT_SERIAL(CNonce, CObject, 1)
IMPLEMENT_SERIAL(CSessionKey, CObject, 1)
IMPLEMENT_SERIAL(CSentance, CObject, 1)

void CUserInfo::Serialize(CArchive &ar){
	if(ar.IsStoring()){
		ar << m_strID;
		ar << m_strName;
		ar << m_nMale;
		ar << m_strOthers;
		m_dibPic.Serialize(ar);
	}else{
		ar >> m_strID;
		ar >> m_strName;
		ar >> m_nMale;
		ar >> m_strOthers;
		m_dibPic.Serialize(ar);
	}
}

int CUserInfo::SetInfo(CString ID, CString Name, int Male, CString Others, CString bmp){
	m_strID = ID;
	m_strName = Name;
	m_nMale = Male;
	m_strOthers = Others;
	CFile file;

	if(file.Open(bmp, CFile::modeRead)==0){
        AfxMessageBox("Picture File not Found! Tray Again!");
		return 0;
	}

	m_dibPic.Read(&file);
	return 1;
}


CUserList::~CUserList(void){
	CUserInfo* ui;
	for(ui=First(); ui!=NULL; ui=Next()){
		delete ui;
	}
}

void CUserList::Serialize(CArchive &ar){
	if(ar.IsStoring()){
		CUserInfo* ui;
		ar << (int)m_mapData.GetCount();
		for(ui=First(); ui!=NULL; ui=Next()){
			ui->Serialize(ar);
		}
	}else{
		CUserInfo* ui;
		int n;
		ar >> n;
		for(int i=0; i<n; i++){
			ui = new CUserInfo;
			ui->Serialize(ar);
			Add(ui);
		}
	}
}

void compute_hash( char* buffer, unsigned char *digest );

void CSentance::Sign(DWORD key[32], int key_len, DWORD base[32], int base_len){
	DWORD temp[32];
	unsigned char *digest;

	temp[0]=0; temp[1]=0;

	for(int i=3; i<31; i++){
		temp[i] = rand();
	}
	temp[31]=0;

	digest = (unsigned char*) &(temp[5]);
	compute_hash((char*)(LPCTSTR) m_strContent, digest);

	IUserRSA* pUserRSA;
	HRESULT hr = CoCreateInstance(CLSID_UserRSA,
	NULL, 
	CLSCTX_INPROC_SERVER, 
	IID_IUserRSA, 
	(void **)&pUserRSA);
	if(hr==REGDB_E_CLASSNOTREG){
		AfxMessageBox("REGDB_E_CLASSNOTREG ");
	}
	if(hr==CLASS_E_NOAGGREGATION){
		AfxMessageBox("CLASS_E_NOAGGREGATION ");
	}
	if(FAILED(hr)){
		AfxMessageBox("IUserRSA failed");
		return;
	}

	int nLen=32;

	pUserRSA->SetBase(base, base_len);
	pUserRSA->SetPrivateExp(key, key_len);
	pUserRSA->ExpModPrivate(temp, base_len, m_pdwSignature, &nLen);

	pUserRSA->Release();
}


int CSentance::Verify(DWORD key[32], int key_len, DWORD base[32], int base_len){
	DWORD temp[32];
	unsigned char *result;
	unsigned char digest[20];

	result = (unsigned char*) &(temp[5]);
	compute_hash( (char*) (LPCTSTR) m_strContent, digest);

	IUserRSA* pUserRSA;
	HRESULT hr = CoCreateInstance(CLSID_UserRSA,
	NULL, 
	CLSCTX_INPROC_SERVER, 
	IID_IUserRSA, 
	(void **)&pUserRSA);
	if(hr==REGDB_E_CLASSNOTREG){
		AfxMessageBox("REGDB_E_CLASSNOTREG ");
	}
	if(hr==CLASS_E_NOAGGREGATION){
		AfxMessageBox("CLASS_E_NOAGGREGATION ");
	}
	if(FAILED(hr)){
		AfxMessageBox("IUserRSA failed");
		return 0;
	}

	int nLen=32;

	pUserRSA->SetBase(base, base_len);
	pUserRSA->SetPublicExp(key, key_len);
	pUserRSA->ExpModPublic(m_pdwSignature,base_len, temp, &nLen);
	pUserRSA->Release();

	for(int i=0; i<20; i++){
		if(digest[i]!=result[i]) return 0;
	}
	return 1;
}

void CSentance::Serialize(CArchive& ar){
	int i;
	if(ar.IsStoring()){
		ar << m_strContent;
		for(i=0; i<32; i++){
			ar << m_pdwSignature[i];
		}
	}else{
		ar >> m_strContent;
		for(i=0; i<32; i++){
			ar >> m_pdwSignature[i];
		}
	}
}

void COnlineUser::SetInfo(CUserInfo* ui, DWORD key[32], int key_size, DWORD base[32], int base_size){
	int i;
	m_nKeySize=key_size;
	m_nBaseSize=base_size;
	for(i=0; i<32; i++) m_pdwBase[i]=base[i];
	for(i=0; i<32; i++) m_pdwPublicKey[i]=key[i];
	m_pUserInfo=ui;
}

void COnlineUser::Serialize(CArchive& ar){
	int i;
	if(ar.IsStoring()){
		m_pUserInfo->Serialize(ar);
		ar << m_nKeySize;
		ar << m_nBaseSize;
		for(i=0; i<32; i++){
			ar << m_pdwPublicKey[i];
			ar << m_pdwBase[i];
		}
	}else{
		m_nIsNew=1;
		CUserInfo* ui;
		ui = new CUserInfo;
		ui->Serialize(ar);
		ar >> m_nKeySize;
		ar >> m_nBaseSize;
		for(i=0; i<32; i++){
			ar >> m_pdwPublicKey[i];
			ar >> m_pdwBase[i];
		}
		m_pUserInfo=ui;
	}
}

COnlineUserList::~COnlineUserList(void){
	COnlineUser* ou;
	for(ou=First(); ou!=NULL; ou=Next()){
		delete ou;
	}
}

void COnlineUserList::Serialize(CArchive &ar){
	if(ar.IsStoring()){
		COnlineUser* ou;
		ar << (int)m_mapData.GetCount();
		for(ou=First(); ou!=NULL; ou=Next()){
			ou->Serialize(ar);
		}
	}else{
		COnlineUser* ou;
		int n;
		ar >> n;
		for(int i=0; i<n; i++){
			ou = new COnlineUser;
			ou->Serialize(ar);
			Add(ou);
		}
	}
}

int CNonce::IsEqual(DWORD data[8]){
	int i;
	for(i=0; i<8; i++){
		if(data[i] != m_pdwData[i]) return 0;
	}
	return 1;
}

void CNonce::CopyTo(DWORD data[8]){
	for(int i=0; i<8; i++) data[i]=m_pdwData[i];
}

void CNonce::Serialize(CArchive& ar){
	int i;
	if(ar.IsStoring()){
		for(i=0; i<8; i++){
			ar << m_pdwData[i];
		}
	}else{
		for(i=0; i<8; i++){
			ar >> m_pdwData[i];
		}
	}
}

void CSessionKey::SetKey(BYTE key[16]){
	for(int i=0; i<16; i++)
		m_pbKey[i] = key[i];
}

void CSessionKey::SetNonce1(DWORD nonce[8]){
	for(int i=0; i<8; i++) m_pdwNonce1[i]=nonce[i];
}

//1 : equal , 0 : otherwise
int CSessionKey::CompareNonce1(DWORD nonce[8]){
	for(int i=0; i<8; i++){
		if(nonce[i]!=m_pdwNonce1[i]) return 0;
	}
	return 1;
}

void CSessionKey::CopyKeyTo(BYTE key[16]){
	for(int i=0; i<16; i++) key[i]=m_pbKey[i];
}

void CSessionKey::CopyNonce2To(DWORD nonce[8]){
	for(int i=0; i<8; i++) nonce[i]=m_pdwNonce2[i];
}

void CSessionKey::Encrypt(DWORD key[32], int key_len, DWORD base[32], int base_len){
	IUserRSA* pUserRSA;
	HRESULT hr = CoCreateInstance(CLSID_UserRSA,
	NULL, 
	CLSCTX_INPROC_SERVER, 
	IID_IUserRSA, 
	(void **)&pUserRSA);
	if(hr==REGDB_E_CLASSNOTREG){
		AfxMessageBox("REGDB_E_CLASSNOTREG ");
	}
	if(hr==CLASS_E_NOAGGREGATION){
		AfxMessageBox("CLASS_E_NOAGGREGATION ");
	}
	if(FAILED(hr)){
		AfxMessageBox("IUserRSA failed");
		return;
	}

	int nLen=32;
	DWORD temp[32];

	pUserRSA->Clear();
	pUserRSA->SetBase(base, base_len);
	pUserRSA->SetPublicExp(key, key_len);
	if(pUserRSA->ExpModPublic(m_pdwData, base_len, temp, &nLen)!=S_OK){
		AfxMessageBox("IUserRSA error!");
	}
	pUserRSA->Release();
	for(int i=0; i<32; i++) m_pdwData[i] = temp[i];
}

void CSessionKey::Decrypt(DWORD key[32], int key_len, DWORD base[32], int base_len){
	IUserRSA* pUserRSA;
	HRESULT hr = CoCreateInstance(CLSID_UserRSA,
	NULL, 
	CLSCTX_INPROC_SERVER, 
	IID_IUserRSA, 
	(void **)&pUserRSA);
	if(hr==REGDB_E_CLASSNOTREG){
		AfxMessageBox("REGDB_E_CLASSNOTREG ");
	}
	if(hr==CLASS_E_NOAGGREGATION){
		AfxMessageBox("CLASS_E_NOAGGREGATION ");
	}
	if(FAILED(hr)){
		AfxMessageBox("IUserRSA failed");
		return;
	}

	int nLen=32;
	DWORD temp[32];
	pUserRSA->Clear();
	pUserRSA->SetBase(base, base_len);
	pUserRSA->SetPrivateExp(key, key_len);
	if(pUserRSA->ExpModPrivate(m_pdwData, base_len, temp, &nLen)!=S_OK){
		AfxMessageBox("IUserRSA error");
	}
	pUserRSA->Release();
	for(int i=0; i<32; i++) m_pdwData[i] = temp[i];
}

void CSessionKey::Serialize(CArchive& ar){
	int i;
	if(ar.IsStoring()){
		for(i=0; i<32; i++){
			ar << m_pdwData[i];
		}
	}else{
		for(i=0; i<32; i++){
			ar >> m_pdwData[i];
		}
	}
}

CString ToString(DWORD *pData, int len)
{
	CString strOut = "";

	BYTE *p = (BYTE *)pData;
	int i;
	for(i = len * 4 -1; i>= 0; i--)
	{
		CString str;
		str.Format("%02x", p[i]);
		strOut += str;
	}
	return strOut;
}



void Randomize(DWORD *pData, int len)
{
	BYTE *p = (BYTE *)pData;
	int i;
	for(i = len * 4 -1; i>= 0; i--)
	{
		p[i] = (rand() & 255);
	}
}
/*
CKeyList::~CKeyList(void){
	IUserRSA* rsa;
	for(rsa=First(); rsa!=NULL; rsa=Next()){
		rsa->Release();
	}
}
*/