// UserInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "chatter.h"
#include "UserInfoDlg.h"
#include "sec\data.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern COnlineUserList* pOnlineUserList;

/////////////////////////////////////////////////////////////////////////////
// CUserInfoDlg dialog

BOOL CUserInfoDlg::Create(void){
	return CDialog::Create(CUserInfoDlg::IDD);
}

CUserInfoDlg::CUserInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUserInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUserInfoDlg)
	m_strID = _T("");
	m_strName = _T("");
	m_strOthers = _T("");
	m_strBase = _T("");
	m_strPublicKey = _T("");
	//}}AFX_DATA_INIT

	m_pFrameWnd=NULL;
	m_pdibPic=NULL;
}


void CUserInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUserInfoDlg)
	DDX_Text(pDX, IDC_ID, m_strID);
	DDV_MaxChars(pDX, m_strID, 128);
	DDX_Text(pDX, IDC_NAME, m_strName);
	DDV_MaxChars(pDX, m_strName, 128);
	DDX_Text(pDX, IDC_OTHERS, m_strOthers);
	DDV_MaxChars(pDX, m_strOthers, 256);
	DDX_Text(pDX, IDC_BASE, m_strBase);
	DDX_Text(pDX, IDC_PUBLIC, m_strPublicKey);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUserInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CUserInfoDlg)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_ONLINEUSERS, OnItemchangedOnlineusers)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUserInfoDlg message handlers

void CUserInfoDlg::OnOK() 
{
	CDialog::OnOK();
}

BOOL CUserInfoDlg::OnInitDialog() 
{

	CDialog::OnInitDialog();

	if(pOnlineUserList == NULL) return TRUE;
	if(pOnlineUserList->IsEmpty()) return TRUE;

	COnlineUser* ou;
	int i;
	m_imageList.Create(16, 16, 0, 0, pOnlineUserList->GetCount());
	CListCtrl* pList=(CListCtrl*) GetDlgItem(IDC_ONLINEUSERS);
	for(i=0, ou=pOnlineUserList->First(); ou!=NULL; ou=pOnlineUserList->Next(), i++){
		HICON hIcon;
		if(ou->m_pUserInfo->m_nMale == 1)
			hIcon=AfxGetApp()->LoadIcon(IDI_GIRL);
		else
			hIcon=AfxGetApp()->LoadIcon(IDI_BOY);
		m_imageList.Add(hIcon);
		pList->InsertItem(i, ou->m_pUserInfo->m_strID, i);
	}
	pList->SetImageList(&m_imageList, LVSIL_SMALL);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CUserInfoDlg::OnItemchangedOnlineusers(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	CListCtrl* pList = (CListCtrl*) GetDlgItem(IDC_ONLINEUSERS);
	int nSelected = pNMListView->iItem;
	if(nSelected>=0){
		CString strItem=pList->GetItemText(nSelected, 0);
		COnlineUser *ou;
		ou = pOnlineUserList->Find(strItem);
		if(ou==NULL){
			AfxMessageBox("OnItemchangedUserlist(...) error!");
			return;
		}
		CUserInfo *ui;
		ui = ou->m_pUserInfo;
		m_strID = ui->m_strID;
		m_strName = ui->m_strName;
		m_strOthers = ui->m_strOthers;
		m_pdibPic = &(ui->m_dibPic);
		m_strBase = ToString(ou->m_pdwBase, ou->m_nBaseSize);
		m_strPublicKey = ToString(ou->m_pdwPublicKey, ou->m_nKeySize);
		UpdateData(FALSE);

		CWnd* pWnd=GetDlgItem(IDC_PIC);
		CDC* pdc = pWnd->GetDC();
		pWnd->Invalidate();
		pWnd->UpdateWindow();
		m_pdibPic->Draw(pdc, CPoint(0, 0), CSize(50,50));
		pWnd->ReleaseDC(pdc);
	}
	
	*pResult = 0;
}

void CUserInfoDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	if(m_pdibPic==NULL) return;
	CWnd* pWnd=GetDlgItem(IDC_PIC);
	CDC* pdc = pWnd->GetDC();
	pWnd->Invalidate();
	pWnd->UpdateWindow();
	m_pdibPic->Draw(pdc, CPoint(0, 0), CSize(50,50));
	pWnd->ReleaseDC(pdc);
	// Do not call CDialog::OnPaint() for painting messages
}
