// VerifyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "chatter.h"
#include "VerifyDlg.h"
#include "sec\data.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern COnlineUserList* pOnlineUserList;

/////////////////////////////////////////////////////////////////////////////
// CVerifyDlg dialog

CVerifyDlg::CVerifyDlg(CFrameWnd *pFrame){
	m_strSig = _T("");
	m_strID = _T("");
	m_strMsg = _T("");
	m_pFrame=pFrame;
}

CVerifyDlg::CVerifyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVerifyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVerifyDlg)
	m_strSig = _T("");
	m_strID = _T("");
	m_strMsg = _T("");
	//}}AFX_DATA_INIT
	m_pFrame=NULL;
}


void CVerifyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVerifyDlg)
	DDX_Text(pDX, IDC_VERFYSIG, m_strSig);
	DDX_Text(pDX, IDC_VERIFYID, m_strID);
	DDX_Text(pDX, IDC_VERIFYMSG, m_strMsg);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVerifyDlg, CDialog)
	//{{AFX_MSG_MAP(CVerifyDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVerifyDlg message handlers

BOOL CVerifyDlg::Create(){
	return CDialog::Create(CVerifyDlg::IDD);
}

void CVerifyDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if(m_pFrame != NULL){
		DestroyWindow();
	}
}

void ToDWORD(CString str, DWORD* pdw){
	int len = str.GetLength();
	unsigned char* src;
	unsigned char* dst;
	dst = (char unsigned*) pdw;
	src=(char unsigned*)(LPCTSTR) str;
	int j=0;
	for(int i=len-1; i>=0;){
		if(src[i]>='0' && src[i] <='9'){
			dst[j] = src[i] - '0';
		}else if(src[i] >= 'a' && src[i] <= 'f'){
			dst[j] = src[i] - 'a' + 10;
		}else{
			AfxMessageBox("Signature error!");
		}
		i--;
		if(src[i]>='0' && src[i] <='9'){
			dst[j] += 16*(src[i] - '0');
		}else if(src[i] >= 'a' && src[i] <= 'f'){
			dst[j] += 16*(src[i] - 'a' + 10);
		}else{
			AfxMessageBox("Signature error!");
		}
		i--;
		j++;
	}
}

extern void compute_hash(char*, unsigned char*);

void CVerifyDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);

	COnlineUser* ou;
	ou = pOnlineUserList->Find(m_strID);
	if(ou == NULL){
		AfxMessageBox("ID unknown!");
		return;
	}

	int len=m_strSig.GetLength();
	if(len != 256){
		AfxMessageBox("Signature error! Retry Again.");
		return;
	}

	BYTE hash[20];
	compute_hash((char*)(LPCTSTR) m_strMsg, hash);

	IUserRSA* pUserRSA;
	HRESULT hr = CoCreateInstance(CLSID_UserRSA,
	NULL, 
	CLSCTX_INPROC_SERVER, 
	IID_IUserRSA, 
	(void **)&pUserRSA);
	if(hr==REGDB_E_CLASSNOTREG){
		AfxMessageBox("REGDB_E_CLASSNOTREG ");
	}
	if(hr==CLASS_E_NOAGGREGATION){
		AfxMessageBox("CLASS_E_NOAGGREGATION ");
	}
	if(FAILED(hr)){
		AfxMessageBox("IUserRSA failed");
		return;
	}

	DWORD temp[32];
	DWORD ans_temp[32];
	int ans=32;
	ToDWORD(m_strSig, temp);
	pUserRSA->SetBase(ou->m_pdwBase, ou->m_nBaseSize);
	pUserRSA->SetPublicExp(ou->m_pdwPublicKey, ou->m_nKeySize);
	pUserRSA->ExpModPublic(temp, 32, ans_temp, &ans);
	pUserRSA->Release();

	BYTE *ptr;
	ptr= (BYTE*) &(ans_temp[10]);
	for(int i=0; i<20; i++){
		if(ptr[i] != hash[i]){
			AfxMessageBox("This Is Not His Signature!");
			return;
		}
	}
	AfxMessageBox("This Is His Signature!");
}
